3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|*' --va'*)
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
50 my $ok = join("|", qw(
59 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
60 print join("\n", @vars);
62 GIT_AUTHOR_EMAIL=author@example.com
63 GIT_AUTHOR_NAME='A U Thor'
64 GIT_COMMITTER_EMAIL=committer@example.com
65 GIT_COMMITTER_NAME='C O Mitter'
67 export GIT_MERGE_VERBOSITY
68 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
69 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
72 # Protect ourselves from common misconfiguration to export
73 # CDPATH into the environment
78 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
80 echo "* warning: Some tests will not work if GIT_TRACE" \
81 "is set as to trace on STDERR ! *"
82 echo "* warning: Please set GIT_TRACE to something" \
83 "other than 1, 2 or true ! *"
89 # A regexp to match 5 and 40 hexdigits
90 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
91 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
94 _z40=0000000000000000000000000000000000000000
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
116 while test "$#" -ne 0
119 -d|--d|--de|--deb|--debu|--debug)
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
129 -q|--q|--qu|--qui|--quie|--quiet)
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
134 with_dashes=t; shift ;;
137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138 valgrind=t; verbose=t; shift ;;
140 shift ;; # was handled already
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
149 if test -n "$color"; then
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
159 *) test -n "$quiet" && return;;
169 test -z "$1" && test -n "$quiet" && return
176 say_color error "error: $*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
190 echo "$test_description"
196 if test "$verbose" = "t"
200 exec 4>/dev/null 3>/dev/null
209 test_external_has_tap=0
213 if test -n "$GIT_EXIT_OK"
217 echo >&5 "FATAL: Unexpected exit with code $code"
225 # The semantics of the editor variables are that of invoking
226 # sh -c "$EDITOR \"$@\"" files ...
228 # If our trash directory contains shell metacharacters, they will be
229 # interpreted if we just set $EDITOR directly, so do a little dance with
230 # environment variables to work around this.
232 # In particular, quoting isn't enough, as the path may contain the same quote
237 EDITOR='"$FAKE_EDITOR"'
241 test_decode_color () {
244 if (n == 0) return "RESET";
245 if (n == 1) return "BOLD";
246 if (n == 30) return "BLACK";
247 if (n == 31) return "RED";
248 if (n == 32) return "GREEN";
249 if (n == 33) return "YELLOW";
250 if (n == 34) return "BLUE";
251 if (n == 35) return "MAGENTA";
252 if (n == 36) return "CYAN";
253 if (n == 37) return "WHITE";
254 if (n == 40) return "BLACK";
255 if (n == 41) return "BRED";
256 if (n == 42) return "BGREEN";
257 if (n == 43) return "BYELLOW";
258 if (n == 44) return "BBLUE";
259 if (n == 45) return "BMAGENTA";
260 if (n == 46) return "BCYAN";
261 if (n == 47) return "BWHITE";
264 while (match($0, /\033\[[0-9;]*m/) != 0) {
265 printf "%s<", substr($0, 1, RSTART-1);
266 codes = substr($0, RSTART+2, RLENGTH-3);
267 if (length(codes) == 0)
270 n = split(codes, ary, ";");
272 for (i = 1; i <= n; i++) {
273 printf "%s%s", sep, name(ary[i]);
278 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
302 sed -e 's/$/Q/' | tr Q '\015'
306 tr '\015' Q | sed -e 's/Q$//'
309 # In some bourne shell implementations, the "unset" builtin returns
310 # nonzero status when a variable to be unset was not set in the first
313 # Use sane_unset when that should not be considered an error.
321 if test -z "${test_tick+set}"
325 test_tick=$(($test_tick + 60))
327 GIT_COMMITTER_DATE="$test_tick -0700"
328 GIT_AUTHOR_DATE="$test_tick -0700"
329 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
332 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
334 # This will commit a file with the given contents and the given commit
335 # message. It will also add a tag with <message> as name.
337 # Both <file> and <contents> default to <message>.
341 echo "${3-$1}" > "$file" &&
344 git commit -m "$1" &&
348 # Call test_merge with the arguments "<message> <commit>", where <commit>
349 # can be a tag pointing to the commit-to-merge.
353 git merge -m "$1" "$2" &&
357 # This function helps systems where core.filemode=false is set.
358 # Use it instead of plain 'chmod +x' to set or unset the executable bit
359 # of a file in the working directory and add it to the index.
363 git update-index --add "--chmod=$@"
366 # Unset a configuration variable, but don't fail if it doesn't exist.
368 git config --unset-all "$@"
370 case "$config_status" in
371 5) # ok, nothing to unset
375 return $config_status
378 # Set git config, automatically unsetting it after the test is over.
380 test_when_finished "test_unconfig '$1'" &&
385 test_config_global () {
386 test_when_finished "test_unconfig --global '$1'" &&
387 git config --global "$@"
392 echo "#!${2-"$SHELL_PATH"}" &&
398 # Use test_set_prereq to tell that a particular prerequisite is available.
399 # The prerequisite can later be checked for in two ways:
401 # - Explicitly using test_have_prereq.
403 # - Implicitly by specifying the prerequisite tag in the calls to
404 # test_expect_{success,failure,code}.
406 # The single parameter is the prerequisite tag (a simple word, in all
407 # capital letters by convention).
410 satisfied="$satisfied$1 "
414 test_have_prereq () {
415 # prerequisites can be concatenated with ','
427 total_prereq=$(($total_prereq + 1))
430 ok_prereq=$(($ok_prereq + 1))
433 # Keep a list of missing prerequisites
434 if test -z "$missing_prereq"
436 missing_prereq=$prerequisite
438 missing_prereq="$prerequisite,$missing_prereq"
443 test $total_prereq = $ok_prereq
446 test_declared_prereq () {
447 case ",$test_prereq," in
455 # You are not expected to call test_ok_ and test_failure_ directly, use
456 # the text_expect_* functions instead.
459 test_success=$(($test_success + 1))
460 say_color "" "ok $test_count - $@"
464 test_failure=$(($test_failure + 1))
465 say_color error "not ok - $test_count $1"
467 echo "$@" | sed -e 's/^/# /'
468 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
471 test_known_broken_ok_ () {
472 test_fixed=$(($test_fixed+1))
473 say_color "" "ok $test_count - $@ # TODO known breakage"
476 test_known_broken_failure_ () {
477 test_broken=$(($test_broken+1))
478 say_color skip "not ok $test_count - $@ # TODO known breakage"
482 test "$debug" = "" || eval "$1"
486 # This is a separate function because some tests use
487 # "return" to end a test_expect_success block early.
488 eval </dev/null >&3 2>&4 "$*"
497 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
499 test_eval_ "$test_cleanup"
501 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
508 test_count=$(($test_count+1))
510 for skp in $GIT_SKIP_TESTS
512 case $this_test.$test_count in
518 if test -z "$to_skip" && test -n "$test_prereq" &&
519 ! test_have_prereq "$test_prereq"
526 if test "$missing_prereq" != "$test_prereq"
528 of_prereq=" of $test_prereq"
531 say_color skip >&3 "skipping test: $@"
532 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
541 test_expect_failure () {
542 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
544 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
548 say >&3 "checking known breakage: $2"
549 if test_run_ "$2" expecting_failure
551 test_known_broken_ok_ "$1"
553 test_known_broken_failure_ "$1"
559 test_expect_success () {
560 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
562 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
566 say >&3 "expecting success: $2"
577 # test_external runs external test scripts that provide continuous
578 # test output about their progress, and succeeds/fails on
579 # zero/non-zero exit code. It outputs the test output on stdout even
580 # in non-verbose mode, and announces the external script with "# run
581 # <n>: ..." before running it. When providing relative paths, keep in
582 # mind that all scripts run in "trash directory".
583 # Usage: test_external description command arguments...
584 # Example: test_external 'Perl API' perl ../path/to/test.pl
586 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
588 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
592 if ! test_skip "$descr" "$@"
594 # Announce the script to reduce confusion about the
595 # test output that follows.
596 say_color "" "# run $test_count: $descr ($*)"
597 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
598 # to be able to use them in script
599 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
600 # Run command; redirect its stderr to &4 as in
601 # test_run_, but keep its stdout on our stdout even in
606 if test $test_external_has_tap -eq 0; then
609 say_color "" "# test_external test $descr was ok"
610 test_success=$(($test_success + 1))
613 if test $test_external_has_tap -eq 0; then
614 test_failure_ "$descr" "$@"
616 say_color error "# test_external test $descr failed: $@"
617 test_failure=$(($test_failure + 1))
623 # Like test_external, but in addition tests that the command generated
624 # no output on stderr.
625 test_external_without_stderr () {
626 # The temporary file has no (and must have no) security
629 stderr="$tmp/git-external-stderr.$$.tmp"
630 test_external "$@" 4> "$stderr"
631 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
632 descr="no stderr: $1"
634 say >&3 "# expecting no stderr from previous command"
635 if [ ! -s "$stderr" ]; then
638 if test $test_external_has_tap -eq 0; then
641 say_color "" "# test_external_without_stderr test $descr was ok"
642 test_success=$(($test_success + 1))
645 if [ "$verbose" = t ]; then
646 output=`echo; echo "# Stderr is:"; cat "$stderr"`
650 # rm first in case test_failure exits.
652 if test $test_external_has_tap -eq 0; then
653 test_failure_ "$descr" "$@" "$output"
655 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
656 test_failure=$(($test_failure + 1))
661 # debugging-friendly alternatives to "test [-f|-d|-e]"
662 # The commands test the existence or non-existence of $1. $2 can be
663 # given to provide a more precise diagnosis.
664 test_path_is_file () {
667 echo "File $1 doesn't exist. $*"
672 test_path_is_dir () {
675 echo "Directory $1 doesn't exist. $*"
680 test_path_is_missing () {
685 if [ $# -ge 1 ]; then
692 # test_line_count checks that a file has the number of lines it
693 # ought to. For example:
695 # test_expect_success 'produce exactly one line of output' '
696 # do something >output &&
697 # test_line_count = 1 output
700 # is like "test $(wc -l <output) = 1" except that it passes the
701 # output through when the number of lines is wrong.
706 error "bug in the test script: not 3 parameters to test_line_count"
707 elif ! test $(wc -l <"$3") "$1" "$2"
709 echo "test_line_count: line count for $3 !$1 $2"
715 # This is not among top-level (test_expect_success | test_expect_failure)
716 # but is a prefix that can be used in the test script, like:
718 # test_expect_success 'complain and die' '
720 # do something else &&
721 # test_must_fail git checkout ../outerspace
724 # Writing this as "! git checkout ../outerspace" is wrong, because
725 # the failure could be due to a segv. We want a controlled failure.
730 if test $exit_code = 0; then
731 echo >&2 "test_must_fail: command succeeded: $*"
733 elif test $exit_code -gt 129 -a $exit_code -le 192; then
734 echo >&2 "test_must_fail: died by signal: $*"
736 elif test $exit_code = 127; then
737 echo >&2 "test_must_fail: command not found: $*"
743 # Similar to test_must_fail, but tolerates success, too. This is
744 # meant to be used in contexts like:
746 # test_expect_success 'some command works without configuration' '
747 # test_might_fail git config --unset all.configuration &&
751 # Writing "git config --unset all.configuration || :" would be wrong,
752 # because we want to notice if it fails due to segv.
757 if test $exit_code -gt 129 -a $exit_code -le 192; then
758 echo >&2 "test_might_fail: died by signal: $*"
760 elif test $exit_code = 127; then
761 echo >&2 "test_might_fail: command not found: $*"
767 # Similar to test_must_fail and test_might_fail, but check that a
768 # given command exited with a given exit code. Meant to be used as:
770 # test_expect_success 'Merge with d/f conflicts' '
771 # test_expect_code 1 git merge "merge msg" B master
774 test_expect_code () {
779 if test $exit_code = $want_code
784 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
788 # test_cmp is a helper function to compare actual and expected output.
789 # You can use it like:
791 # test_expect_success 'foo works' '
792 # echo expected >expected &&
794 # test_cmp expected actual
797 # This could be written as either "cmp" or "diff -u", but:
798 # - cmp's output is not nearly as easy to read as diff -u
799 # - not all diff versions understand "-u"
805 # This function can be used to schedule some commands to be run
806 # unconditionally at the end of the test to restore sanity:
808 # test_expect_success 'test core.capslock' '
809 # git config core.capslock true &&
810 # test_when_finished "git config --unset core.capslock" &&
814 # That would be roughly equivalent to
816 # test_expect_success 'test core.capslock' '
817 # git config core.capslock true &&
819 # git config --unset core.capslock
822 # except that the greeting and config --unset must both succeed for
825 # Note that under --immediate mode, no clean-up is done to help diagnose
828 test_when_finished () {
830 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
833 # Most tests can use the created repository, but some may need to create more.
834 # Usage: test_create_repo <directory>
835 test_create_repo () {
837 error "bug in the test script: not 1 parameter to test-create-repo"
841 cd "$repo" || error "Cannot setup test environment"
842 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
843 error "cannot run git init -- have you built things yet?"
844 mv .git/hooks .git/hooks-disabled
851 if test -z "$HARNESS_ACTIVE"; then
852 test_results_dir="$TEST_DIRECTORY/test-results"
853 mkdir -p "$test_results_dir"
854 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
856 cat >>"$test_results_path" <<-EOF
858 success $test_success
866 if test "$test_fixed" != 0
868 say_color pass "# fixed $test_fixed known breakage(s)"
870 if test "$test_broken" != 0
872 say_color error "# still have $test_broken known breakage(s)"
873 msg="remaining $(($test_count-$test_broken)) test(s)"
875 msg="$test_count test(s)"
877 case "$test_failure" in
879 # Maybe print SKIP message
880 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
882 if test $test_external_has_tap -eq 0; then
883 say_color pass "# passed all $msg"
884 say "1..$test_count$skip_all"
887 test -d "$remove_trash" &&
888 cd "$(dirname "$remove_trash")" &&
889 rm -rf "$(basename "$remove_trash")"
894 if test $test_external_has_tap -eq 0; then
895 say_color error "# failed $test_failure among $msg"
904 # Test the binaries we have just built. The tests are kept in
905 # t/ subdirectory and are run in 'trash directory' subdirectory.
906 if test -z "$TEST_DIRECTORY"
908 # We allow tests to override this, in case they want to run tests
909 # outside of t/, e.g. for running tests on the test library
911 TEST_DIRECTORY=$(pwd)
913 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
915 if test -n "$valgrind"
919 test "$1" = "$(readlink "$2")" || {
927 while test -d "$2".lock
929 say "Waiting for lock on $2."
936 make_valgrind_symlink () {
937 # handle only executables, unless they are shell libraries that
938 # need to be in the exec-path. We will just use "#!" as a
939 # guess for a shell-script, since we have no idea what the user
940 # may have configured as the shell path.
942 test "#!" = "$(head -c 2 <"$1")" ||
945 base=$(basename "$1")
946 symlink_target=$GIT_BUILD_DIR/$base
947 # do not override scripts
948 if test -x "$symlink_target" &&
949 test ! -d "$symlink_target" &&
950 test "#!" != "$(head -c 2 < "$symlink_target")"
952 symlink_target=../valgrind.sh
956 symlink_target=../unprocessed-script
958 # create the link, or replace it if it is out of date
959 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
962 # override all git executables in TEST_DIRECTORY/..
963 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
964 mkdir -p "$GIT_VALGRIND"/bin
965 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
967 make_valgrind_symlink $file
969 # special-case the mergetools loadables
970 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
975 ls "$path"/git-* 2> /dev/null |
978 make_valgrind_symlink "$file"
982 PATH=$GIT_VALGRIND/bin:$PATH
983 GIT_EXEC_PATH=$GIT_VALGRIND/bin
985 elif test -n "$GIT_TEST_INSTALLED" ; then
986 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
987 error "Cannot run git from $GIT_TEST_INSTALLED."
988 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
989 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
990 else # normal case, use ../bin-wrappers only unless $with_dashes:
991 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
992 if ! test -x "$git_bin_dir/git" ; then
993 if test -z "$with_dashes" ; then
994 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
998 PATH="$git_bin_dir:$PATH"
999 GIT_EXEC_PATH=$GIT_BUILD_DIR
1000 if test -n "$with_dashes" ; then
1001 PATH="$GIT_BUILD_DIR:$PATH"
1004 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1006 GIT_CONFIG_NOSYSTEM=1
1008 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1010 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1012 if test -z "$GIT_TEST_CMP"
1014 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1016 GIT_TEST_CMP="$DIFF -c"
1018 GIT_TEST_CMP="$DIFF -u"
1022 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1024 test -d "$GIT_BUILD_DIR"/templates/blt || {
1025 error "You haven't built things yet, have you?"
1028 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1030 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1032 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1033 error "You haven't built git_remote_helpers yet, have you?"
1037 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1038 echo >&2 'You need to build test-chmtime:'
1039 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1044 test="trash directory.$(basename "$0" .sh)"
1045 test -n "$root" && test="$root/$test"
1047 /*) TRASH_DIRECTORY="$test" ;;
1048 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1050 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1053 echo >&5 "FATAL: Cannot prepare test area"
1057 HOME="$TRASH_DIRECTORY"
1060 test_create_repo "$test"
1061 # Use -P to resolve symlinks in our working directory so that the cwd
1062 # in subprocesses like git equals our $PWD (for pathname comparisons).
1063 cd -P "$test" || exit 1
1066 this_test=${this_test%%-*}
1067 for skp in $GIT_SKIP_TESTS
1069 case "$this_test" in
1071 say_color skip >&3 "skipping test $this_test altogether"
1072 skip_all="skip all tests in $this_test"
1077 # Provide an implementation of the 'yes' utility
1092 # Fix some commands on Windows
1095 # Windows has its own (incompatible) sort and find
1105 # git sees Windows-style pwd
1109 # no POSIX permissions
1110 # backslashes in pathspec are converted to '/'
1111 # exec does not inherit the PID
1112 test_set_prereq MINGW
1113 test_set_prereq SED_STRIPS_CR
1116 test_set_prereq POSIXPERM
1117 test_set_prereq EXECKEEPSPID
1118 test_set_prereq NOT_MINGW
1119 test_set_prereq SED_STRIPS_CR
1122 test_set_prereq POSIXPERM
1123 test_set_prereq BSLASHPSPEC
1124 test_set_prereq EXECKEEPSPID
1125 test_set_prereq NOT_MINGW
1129 test -z "$NO_PERL" && test_set_prereq PERL
1130 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1131 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1132 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1134 # Can we rely on git's output in the C locale?
1135 if test -n "$GETTEXT_POISON"
1137 GIT_GETTEXT_POISON=YesPlease
1138 export GIT_GETTEXT_POISON
1139 test_set_prereq GETTEXT_POISON
1141 test_set_prereq C_LOCALE_OUTPUT
1144 # Use this instead of test_cmp to compare files that contain expected and
1145 # actual output from git commands that can be translated. When running
1146 # under GETTEXT_POISON this pretends that the command produced expected
1149 test -n "$GETTEXT_POISON" || test_cmp "$@"
1152 # Use this instead of "grep expected-string actual" to see if the
1153 # output from a git command that can be translated either contains an
1154 # expected string, or does not contain an unwanted one. When running
1155 # under GETTEXT_POISON this pretends that the command produced expected
1158 if test -n "$GETTEXT_POISON"
1161 elif test "x!" = "x$1"
1170 # test whether the filesystem supports symbolic links
1171 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1174 # When the tests are run as root, permission tests will report that
1175 # things are writable when they shouldn't be.
1176 test -w / || test_set_prereq SANITY